Attribute VB_Name = "MegaIF"
Public ZL As Double        'Lnge Zylinder
Public ZB As Double        'Breite Zylinder
Public ZH As Double        'Hhe Zylinder

Type P_eck
P_P(0 To 7, 0 To 2) As Double
End Type
'/**********************************************************************/
'/* The functions of the MegaCAD interface.                            */
'/**********************************************************************/

'**********************************************************************/
'* Data-types common to all entity-types.                             */
'**********************************************************************/

Type t_symbol
    size As Double          ' size, if absolute
    iType As Integer        ' type, bits see below
    perc As Byte            ' size, if relative (in percent of drawing window)
    fAbs As Byte            ' absolute size?
End Type

Type t_attribs
    Stl As Byte           ' linestyle (1 -  14)
    pen As Byte           ' pen       (0 -  15) user sees (1 - 16) !!!
    col As Byte           ' colour    (1 - 255)
    wid As Byte           ' linewidth (1 -   8)
    lay As Integer        ' layer
    grp As Integer        ' group
    iID As Integer        ' id of entity info
End Type

Public NO_t_attribs As t_attribs

Type t_AttribValues
    iGRP As Long
    iLAY As Long
    iPen As Long
    iSTL As Long
    iCOL As Long
    iWID As Long
End Type

Type t_txtval
    w1 As Double         ' Text-Angle
    w2 As Double         ' Direction
    dx As Double         ' char-width
    dy As Double         ' char-height
    sx As Double         ' space between two chars
    ld As Double         ' line distance, relative to char-height
End Type

Type t_txtfnt
    sName As String        ' facename with TRUETYPE, filename with vector
    CharSet As Byte        ' values see GT_ - Constants
    PitchAndFamily As Byte ' values see GT_ - Constants
    System As Byte         ' values see GT_ - Constants
    Attribs As Byte        ' values see GT_ - Constants
End Type

Type t_point
    x As Double            ' x-coordinate of point
    y As Double            ' y-coordinate of point
End Type

Type t_circle
    ctr As t_point         ' centre point
    rd As Double           ' radius
End Type

Type t_c_arc
    ctr As t_point       ' centre point
    rd As Double         ' radius
    a1 As Double         ' start angle
    a2 As Double         ' end   angle
End Type

Type t_ellipse
    ctr As t_point       ' centre point
    ra As Double         ' 1st half axis
    rb As Double         ' 2nd half axis
    an As Double         ' rotation angle
End Type

Type t_e_arc
    ctr As t_point       ' centre point
    ra As Double         ' 1st half axis
    rb As Double         ' 2nd half axis
    an As Double         ' rotation angle
    a1 As Double         ' start angle (relative to rotation angle)
    a2 As Double         ' end   angle (relative to rotation angle)
End Type

Type t_point3D
    x As Double            ' x-coordinate of point
    y As Double            ' y-coordinate of point
    z As Double            ' z-coordinate of point
End Type

Type t_point3D_4
    aPnts(0 To 3) As t_point3D
End Type

Type t_vector
    x As Double
    y As Double
End Type

Type t_vector3D
    x As Double
    y As Double
    z As Double
End Type

Type t_angle_2
    a1 As Double            ' first angle
    a2 As Double            ' second angle
End Type

Type t_line
    pnt1 As t_point         ' start point
    pnt2 As t_point         ' end point
End Type

Type t_sympnt
    pnt As t_point       ' coordinates
    sym As t_symbol      ' symbol description
End Type

Type t_rect
    pnt1 As t_point         ' lower left
    pnt2 As t_point         ' upper right
End Type

Type t_lin3D
    pnt1 As t_point3D       ' start point
    pnt2 As t_point3D       ' end point
End Type

Type t_text
    val As t_txtval          ' text attributes (see above)
    fnt As t_txtfnt          ' text font (see above)
    fIns As Byte             ' insert point (0-8) left to right, bottom to top
    fDrg As Byte             ' drag point (0-8) left to right, bottom to top
    fFmt As Byte             ' alignment of block (left(0),right(1),centre(2)
    fVar As Byte             ' parametric text, 1=only identifier, 2=filled in
    tpos As t_point          ' coordinates of text start point
    dx1 As Double            ' baseline vector x-value
    dy1 As Double            ' baseline vector y-value
    dx2 As Double            ' leftside vector x-value
    dy2 As Double            ' leftside vector y-value
    align As Integer         ' just for alignment
    numl As Integer          ' number of lines
    str As String            ' char - string
End Type                ' programmer has to set tpos.x, tpos.y, numl (if E_TXTBLK) and str
                        ' other members are obtained by GetTxtVal
                        
Type t_dimension
    val As t_txtval      ' text attributes (see above)
    fnt As t_txtfnt      ' text font (see above)
    align As Long        ' just for alignment
    pntText As t_point   ' text start point
    dx1 As Double        ' baseline vector x-value
    dy1 As Double        ' baseline vector y-value
    dx2 As Double        ' leftside vector x-value
    dy2 As Double        ' leftside vector y-value
    pnt1 As t_point      ' 1st point
    pnt2 As t_point      ' 2nd point
    pnt3 As t_point      ' 3rd point
    pnt4 As t_point      ' 4th point
    a_hig As Double      ' arrow height
    a_wid As Double      ' arrow width
    a_qud As Double      ' arrow quad
    a_rad As Double      ' arrow radius
    a_len As Double      ' arrow length
    value As Double      ' measured value
    len2  As Double      ' length of dim. h-line
    lenc  As Double      ' length of gap with 'nocut'
    hlcol As Byte        ' colour of dim. h-line
    hlwid As Byte        ' linewidth of dim. h-line
    hlpen As Byte        ' pen number of dim. h-line
    
    tcol As Byte         ' colour of dim. text
    twid As Byte         ' linewidth of dim. text
    tpen As Byte         ' pen number of dim. text
    vpos As Byte         ' vertical pos.   ( left, mid, right, free )
    
    hpos As Byte         ' horizontal pos. ( under, above, mid )
    plft As Byte         ' arrow type (1 - 7) of 1st arrow
    prgt As Byte         ' arrow type (1 - 7) of 2nd arrow
    xyon As Byte         ' coordinate dim. type no. (0-3)
    
    reli As Byte         ' which arrows/dim.lines are to be drawn
    nins As Byte         ' whether inner line of outward dim. is forbidden
    str2 As Byte         ' two tolerance text strings ?
    para As Byte         ' is text parallel to dim. line ?
    
    edit As Byte         ' has text been edited ?
    insd As Byte         ' arrows inside ?
    mbox As Byte         ' E_T_DIM with box ?
    arch As Byte         ' architecture dimension ?
    
    fill As Byte         ' fill arrow type 2 ?
    ncut As Byte         ' don't cut off trailing zeroes
    comm As Byte         ' 0-15 comma, 16-23 fractional, 24-31 foot/inch
    flag As Byte         ' (flag&1) round to .0/.5, (flag&2) degrees/minutes/seconds
    
    radk As Byte         ' radius with edge
    brac As Byte         ' dim. text with braces
    fase2 As Byte        ' chamfer 2 (45)
    fase As Byte         ' chamfer angle      (special case of RMASS)

    dm As Byte           ' diameter with edge (special case of RMASS)
    hlcut As Byte        ' help lines don't intersect anything
    txcut As Byte        ' text box not intersected
    pref As Byte         ' number of bytes before measured number
    
    post As Byte         ' number of bytes after measured number
    str As String        ' char - string
    
End Type


Type t_dimsets
    val As t_txtval       ' text attributes (see above)
    fnt As t_txtfnt       ' text font (see above)
    fLeng1 As Byte        ' leng1 on?
    fLeng2 As Byte        ' leng2 on?
    fFactor As Byte       ' factor on?
    pabs As Byte          ' arrow values absolute?
    leng1 As Double       '
    leng2 As Double       '
    factor As Double      '
    txtdist As Double     '
    gap As Double         '
    a_hig As Double       ' arrow height
    a_wid As Double       ' arrow width
    a_qud As Double       ' arrow quad
    a_rad As Double       ' arrow radius
    a_len As Double       ' arrow length

    tol11 As String       '  BASIC - string
    tol12 As String       '  BASIC - string
    tol21 As String       '  BASIC - string
    tol22 As String       '  BASIC - string
    szPref As String      '  BASIC - string
    szPost As String      '  BASIC - string

    fPref As Byte         ' szPref / szPost used ?
    fTol As Byte          ' 0:none 1:tol11/12 2:tol21/22
    hlcol As Byte         ' colour of dim. h-line
    hlwid As Byte         ' linewidth of dim. h-line
    hlpen As Byte         ' pen number of dim. h-line
    tcol As Byte          ' colour of dim. text
    twid As Byte          ' linewidth of dim. text
    tpen As Byte          ' pen number of dim. text
    decComm As Byte       ' decimal comma
    fracComm As Byte      ' fractional comma
    fComm As Byte         ' 0:fractional / 1:decimal
    flag As Byte          ' (flag&1) round to .0/.5, (flag&2) degrees/minutes/seconds
    brac As Byte          ' dim. text with braces
    ncut As Byte          ' don't cut off trailing zeroes
    arch As Byte          ' architecture dimension ?
    sigNr As Byte         ' radius/diameter... sign?
    xyon As Byte          ' coordinate dim. type no. (0-3)
    plft As Byte          ' arrow type (1 - 7) of 1st arrow
    prgt As Byte          ' arrow type (1 - 7) of 2nd arrow
    fill As Byte          ' fill arrow type 2 ?
    insd As Byte          ' arrows inside ?
    str2 As Byte          ' two tolerance text strings ?
    reli As Byte          ' which arrows/dim.lines are to be drawn
    vpos As Byte          ' vertical pos.   ( left, mid, right, free )
    hpos As Byte          ' horizontal pos. ( under, above, mid )
    para As Byte          ' is text parallel to dim. line ?
    aDia As Byte          ' automatic Diameter sign with circles
    aRad As Byte          ' automatic Radius sign with arcs
    sort As Byte          ' normal, chain, reference?
    nins As Byte          ' whether inner line of outward dim. is forbidden
    hlcut As Byte         ' help lines don't intersect anything
    txcut As Byte         ' text box not intersected
End Type

Type t_macro
    name As String       ' filename of macro file
    align As Integer     ' just for alignment
    numl As Integer      ' number of lines of macro info
    info() As String     ' 'numl' lines of info
End Type

Type t_Obj3D
    body_data As Long         ' body handle
    ptr As Long               ' reserved
    flags As Long             ' reserved
End Type

Type t_DrawInvObj
    pnt3d As t_point3D   ' point to compare mouse position with
    hPtr1 As Long        ' used internally by MegaCAD!
    hPtr2 As Long        ' used internally by MegaCAD!
    i As Long            ' used internally by MegaCAD!
End Type

Type t_polypt
   mpd As Double         ' signed distance of vertex
   pnt As t_point        ' coordinates of point
End Type

Type t_polyln
    rec As t_rect         ' surrounding rectangle
    a_hig As Double       ' arrow height
    a_wid As Double       ' arrow width
    a_qud As Double       ' arrow quad
    a_rad As Double       ' arrow radius
    fArea As Byte         ' is an area (filled in background colour)
    fnFrame As Byte       ' frame (lines & arcs) not drawn
    atype As Byte         ' arrow type (1 - 6) (0 => no arrow)
    afill As Byte         ' arrow filled ?
    align As Integer      ' just for alignment
    num As Integer        ' number of polyline points
    ppt() As t_polypt     ' array of polyline points
End Type

Type t_polygon
    align As Integer      ' just for alignment
    num As Integer        ' number of points
    points() As t_point   ' array of points
End Type

Type t_Polygon3D
    num As Long           ' number of points
    pnt() As t_point3D    ' array of points
End Type

Type t_pattern
    rec As t_rect         ' surrounding rectangle
    vec As t_vector       ' alignment vector
    fac As Double         ' factor
    phi As Double         ' rotation angle
    nam As String         ' cross-hatch name, max 7 Char are used ('xhatch.ini')
    align As Integer      ' just for alignment
    num As Integer        ' number of polyline points
    ppt() As t_polypt     ' array of polyline points
End Type

Type t_entinfo
    id As Integer           ' id
    numl As Integer         ' number of lines of text
    info() As String        ' text
End Type

Type t_macinfo
    rpnt As t_point3D       ' ! point of reference
    srec(0 To 2) As t_rect  ' room for 3 stretch rectangles
    numr As Integer         ' number of stretch rectangles
    numl As Integer         ' number of lines of text
    info() As String        ' text
End Type

Type t_grid
    a1 As Double
    a2 As Double            ' angles (Cartesian: 0.0, PI/2)
    dx As Double
    dy As Double            ' steps  (in mm)
End Type                    ' for a polar grid only 'dx' is used

Type t_gridsets
   DrawGrid As t_grid       ' draw grid
   SnapGrid As t_grid       ' snap grid
   PtGrid As t_point        ' reference point for grid
   PtKeybd As t_point       ' reference point for keyboard input
   UnitFactor As Double     ' 1.0 for mm, 10.0 for cm, ...
   iUnit As Integer         ' 0=inch,1=mm,2=foot,3=cm,4=yard,5=m,6=factor
   fCartesian As Byte       ' cartesian vs. polar
   fDraw As Byte            ' grid visible?
   fDrawVals As Byte        ' values of 'DrawGrid' active?
   fSnapVals As Byte        ' values of 'SnapGrid' active?
End Type

Type t_LayGrpDta
    num As Integer          ' ! layer or group number
    flags As Byte           ' ! LGF_ON ...
    level As Byte           ' ! root is 0, first layer 1....
    pflags As Byte          ' ! LGP_...
    txt As String           ' ! Basic-String, maximum strlen is LG_MAXLEN (62!) !!
End Type

Public Const FM_EXCLUSIVE    As Long = (2 ^ 0)
Public Const FM_TAKE_FAC     As Long = (2 ^ 1)
Public Const FM_TAKE_YFAC    As Long = (2 ^ 2)
Public Const FM_TAKE_PHI     As Long = (2 ^ 3)
Public Const FM_TAKE_DPT     As Long = (2 ^ 4)
Public Const FM_TAKE_DPT3D   As Long = (2 ^ 5)
Public Const FM_ONLY1        As Long = (2 ^ 6)
Public Const FM_NO_SAVECOUNT As Long = (2 ^ 7)
Public Const FM_TAKE_FRM     As Long = (2 ^ 8)
Public Const FM_TAKE_ZFAC    As Long = (2 ^ 9)
Public Const FM_TAKE_RPT     As Long = (2 ^ 10)
Public Const FM_TAKE_DCS     As Long = (2 ^ 11)

Type t_mat44
    mat(0 To 3, 0 To 3) As Double
End Type

Public NO_t_mat44 As t_mat44

Type t_mat33
    mat(0 To 2, 0 To 2) As Double
End Type

Type t_MacroPosData
    xfac As Double
    yfac As Double
    phi As Double
End Type

Type t_placemac
    fac As Double         ' scaling factor
    yfac As Double        ' y scaling factor
    zfac As Double        ' z scaling factor
    phi As Double         ' rotation angle
    pnt3d As t_point3D    ' destination point
    mcs As t_mat44        ' model coordinate system
    dcs As t_mat44        ' destination coordinate system
    flags As Long         ' flags (see Public Const's FM_... above)
End Type
             
Type t_applic
    id As Integer       ' ! application ID
    flags As Integer    ' ! flags (APP_LOCKED...)
    L1 As Long          ' ! application data
    L2 As Long          ' ! application data
End Type

Public NO_t_applic As t_applic


Type t_entity
    iType As Integer
    attr As t_attribs
    id As Long
    appl As t_applic
    hData As Long
    hEcs As Long        ' for internal use only, do not change or use!
    ecs As t_mat44
End Type

Type t_Adf
    pol_cnt As Long
    pnt_cnt As Long
    pol_lst() As Long
    pnt_lst() As t_point3D
    ecs As t_mat44
End Type

Type t_ProjPara
   xvec As t_vector3D         ' X-vector of the projection plane
   yvec As t_vector3D         ' Y-vector of the projection plane
   vDir As t_vector3D         ' direction of projection
   eyepos As t_point3D        ' Coordinates of the eye point
   dist_front As Double       ' Clip to this Distance
   dist_behind As Double      ' Clip behind this Distance
   fperspective As Byte       ' TRUE if perspective projection
   fparallel As Byte          ' TRUE if parallel projection
   fhid As Byte               ' TRUE if hidden segments needed
   fclp_front As Byte         ' TRUE if front clipp is on
   fclp_behind As Byte        ' TRUE if behind clipp is on
End Type

Type t_SkinCurv
    num As Long
    ppt() As t_polypt         ' array of polyline points
    ecs As t_mat44
End Type

Type t_name
    id As Long
    typ As Integer             ' entity typ
    exclusive As Integer       ' exclusive
    name As String             '
End Type

Type t_LayerGroupUsedFlags
    flags(0 To 8191) As Byte
End Type

Type t_layoutdta
    name As String         ' name of layout,  BASIC - string
    width As Double        '
    height As Double       ' width and height of complete paper page
    rLeft As Double        '
    rTop As Double         '
    rRight As Double       '
    rBottom As Double      ' differences that give the 'printable' area
    sid As Long            ' id of layout sheet
End Type
                                       
Type t_OpenGL
    transparenz As Integer            ' 0-100!!
    dspMode As Integer
    fIgnElm As Integer
    fRayNew As Integer
    fDraw2D As Integer
End Type
                                       
Public Const APP_LOCKED As Integer = 1  ' (1<<0)
Public Const APP_NOTIFY As Integer = 2  ' (1<<1)

Public Const E_TXTLIN   As Integer = 1
Public Const E_POINT    As Integer = 2
Public Const E_LINE     As Integer = 3
Public Const E_CIRCLE   As Integer = 4
Public Const E_C_ARC   As Integer = 5
Public Const E_H_DIM   As Integer = 6
Public Const E_V_DIM    As Integer = 7
Public Const E_P_DIM    As Integer = 8
Public Const E_A_DIM   As Integer = 9
Public Const E_D_DIM   As Integer = 10
Public Const E_R_DIM   As Integer = 11
Public Const E_T_DIM   As Integer = 12
Public Const E_SPLINE As Integer = 13

Public Const E_TXTBLK   As Integer = 15
Public Const E_MACRO    As Integer = 16

Public Const E_XHATCH   As Integer = 18
Public Const E_ELLIPS As Integer = 19
Public Const E_E_ARC   As Integer = 20

Public Const E_POLYLN   As Integer = 22
Public Const E_BITMAP As Integer = 23
Public Const E_MIDLIN As Integer = 24

Public Const E_OBJ3D   As Integer = 27

Public Const E_FEMBED As Integer = 32
Public Const E_ENDMAC As Integer = 33

' Type flags
Public Const E_TXTLIN_FLAG   As Long = 2 ^ E_TXTLIN
Public Const E_POINT_FLAG    As Long = 2 ^ E_POINT
Public Const E_LINE_FLAG     As Long = 2 ^ E_LINE
Public Const E_CIRCLE_FLAG   As Long = 2 ^ E_CIRCLE
Public Const E_C_ARC_FLAG   As Long = 2 ^ E_C_ARC
Public Const E_H_DIM_FLAG   As Long = 2 ^ E_H_DIM
Public Const E_V_DIM_FLAG    As Long = 2 ^ E_V_DIM
Public Const E_P_DIM_FLAG    As Long = 2 ^ E_P_DIM
Public Const E_A_DIM_FLAG   As Long = 2 ^ E_A_DIM
Public Const E_D_DIM_FLAG   As Long = 2 ^ E_D_DIM
Public Const E_R_DIM_FLAG   As Long = 2 ^ E_R_DIM
Public Const E_T_DIM_FLAG   As Long = 2 ^ E_T_DIM
Public Const E_SPLINE_FLAG As Long = 2 ^ E_SPLINE

Public Const E_TXTBLK_FLAG   As Long = 2 ^ E_TXTBLK
Public Const E_MACRO_FLAG    As Long = 2 ^ E_MACRO

Public Const E_XHATCH_FLAG   As Long = 2 ^ E_XHATCH
Public Const E_ELLIPS_FLAG As Long = 2 ^ E_ELLIPS
Public Const E_E_ARC_FLAG   As Long = 2 ^ E_E_ARC

Public Const E_POLYLN_FLAG   As Long = 2 ^ E_POLYLN
Public Const E_BITMAP_FLAG As Long = 2 ^ E_BITMAP
Public Const E_MIDLIN_FLAG As Long = 2 ^ E_MIDLIN

Public Const E_OBJ3D_FLAG  As Long = 2 ^ E_OBJ3D

Public Const E_FEMBED_FLAG As Long = 2 ^ (E_FEMBED - 31)
Public Const E_ENDMAC_FLAG As Long = 2 ^ (E_ENDMAC - 31)

Public Const E_ALL_FLAG As Long = -1

Public Const POLYLN_MAX As Integer = 1300
Public Const POLYGON_MAX As Integer = 1900

Public Const DO_SAVCNT As Long = (2 ^ 7)

' Zeichenmodi
Public Const PIX_XOR As Integer = 2
Public Const PIX_REP As Integer = 3
Public Const PIX_NO  As Integer = 4

' MegaCAD colour values
Public Const BLACK          As Integer = 0
Public Const BLUE           As Integer = 1
Public Const GREEN          As Integer = 2
Public Const CYAN           As Integer = 3
Public Const RED            As Integer = 4
Public Const MAGENTA        As Integer = 5
Public Const YELLOW         As Integer = 6
Public Const WHITE          As Integer = 7
Public Const BRIGHT_BLACK   As Integer = 8
Public Const BRIGHT_BLUE    As Integer = 9
Public Const BRIGHT_GREEN   As Integer = 10
Public Const BRIGHT_CYAN    As Integer = 11
Public Const BRIGHT_RED     As Integer = 12
Public Const BRIGHT_MAGENTA As Integer = 13
Public Const BRIGHT_YELLOW  As Integer = 14
Public Const BRIGHT_WHITE   As Integer = 15

' Snap-Mode
Public Const SNP_NIX    As Integer = 0
Public Const SNP_MID    As Integer = 5
Public Const SNP_END    As Integer = 6
Public Const SNP_ONELM  As Integer = 8
Public Const SNP_SWP3   As Integer = 24


Public Const CONTINUE_LOOP   As Integer = 0
Public Const CALL_SAVECOUNT As Integer = 1
Public Const BREAK_LOOP As Integer = 2

Public Const CALC_PERIM   As Integer = 0
Public Const CALC_AREA    As Integer = 1
Public Const CALC_GRAVITY As Integer = 2

Public Const LAY_ON   As Integer = (2 ^ 0)
Public Const LAY_LOCK As Integer = (2 ^ 1)
Public Const LAY_ATTR As Integer = (2 ^ 2)

Public Const GRP_ON  As Integer = (2 ^ 4)
Public Const GRP_LOCK As Integer = (2 ^ 5)
Public Const GRP_ATTR As Integer = (2 ^ 6)

Public Const PART_ALL As Integer = 1
Public Const PART_MAC As Integer = 2
Public Const PART_ENT As Integer = 4

Public Const SCF_EXTRACT  As Long = 1
Public Const SCF_ASK_2DWS As Long = 0
Public Const SCF_DO_2DWS  As Long = 2
Public Const SCF_NO_2DWS  As Long = 4

Public Const pi As Double = 3.14159265358979

Public Const MI_VERSION As Integer = 7

' Constants for t_txtfnt
' text font 'System' values
Public Const GT_TRUETYPE As Integer = 0
Public Const GT_VECTOR   As Integer = 1

' text font 'PitchAndFamily' values
Public Const GT_FFDONTCARE  As Integer = 0
Public Const GT_ROMAN       As Integer = 16 ' 0x10
Public Const GT_SWISS       As Integer = 32 ' 0x20
Public Const GT_MODERN      As Integer = 48 ' 0x30
Public Const GT_SCRIPT      As Integer = 64 ' 0x40
Public Const GT_DECORATIVE  As Integer = 90 ' 0x50

Public Const GT_FIXED       As Integer = 1
Public Const GT_VARIABLE    As Integer = 2

' text font 'CharSet' values
Public Const GT_ANSI       As Integer = 0
Public Const GT_SYMBOL     As Integer = 2
Public Const GT_ASIAN      As Integer = 3
Public Const GT_OEM        As Integer = 255

' text font 'Attribs' bits
Public Const GT_ITALIC      As Integer = (2 ^ 0)
Public Const GT_STRIKEOUT   As Integer = (2 ^ 1)
Public Const GT_UNDERLINE   As Integer = (2 ^ 2)
Public Const GT_BOLD        As Integer = (2 ^ 3)
Public Const GT_ISDOWN      As Integer = (2 ^ 4)

' layer / group interface


Public Const LAYGRP_MAXLEN  As Integer = 62

Public Const LGF_ON         As Integer = (2 ^ 0)
Public Const LGF_LOCK       As Integer = (2 ^ 1)
Public Const LGF_ATTR       As Integer = (2 ^ 2)
Public Const LGF_EXPAND     As Integer = (2 ^ 3)

Public Const LGPF_PARENT    As Integer = (2 ^ 0)
Public Const LGPF_CHILD     As Integer = (2 ^ 1)
Public Const LGPF_PREV      As Integer = (2 ^ 2)
Public Const LGPF_NEXT      As Integer = (2 ^ 3)

Public Const LGOP_GETNEXT      As Integer = 1
Public Const LGOP_GETCHILD     As Integer = 2
Public Const LGOP_GETPREV      As Integer = 3
Public Const LGOP_GETPARENT    As Integer = 4
Public Const LGOP_LINEARNEXT   As Integer = 5
Public Const LGOP_VISIBLENEXT As Integer = 6
Public Const LGOP_LASTCHILD    As Integer = 7

Public Const LGOP_GETDATA      As Integer = 11
Public Const LGOP_SETDATA      As Integer = 12
Public Const LGOP_INS_ASCHILD As Integer = 13
Public Const LGOP_INS_ASNEXT   As Integer = 14
Public Const LGOP_MOV_ASCHILD As Integer = 15
Public Const LGOP_MOV_ASNEXT   As Integer = 16
Public Const LGOP_CHK_ASCHILD As Integer = 17
Public Const LGOP_CHK_ASNEXT   As Integer = 18
Public Const LGOP_DELETE       As Integer = 19

Public Const LGINF_GETCOUNT    As Integer = 101

Public Const LGITEM_ROOT       As Long = 1

Public Const LGL_GROUP         As Long = 1
Public Const LGL_LAYER         As Long = 2

Public Const LGERR_INVALIDLIST   As Integer = 1
Public Const LGERR_INVALIDITEM   As Integer = 2
Public Const LGERR_DATANEEDED    As Integer = 3
Public Const LGERR_NUMTWICE      As Integer = 4
Public Const LGERR_MEMORY        As Integer = 5
Public Const LGERR_RECURSIVE     As Integer = 6
Public Const LGERR_MAXLEVEL      As Integer = 7
Public Const LGERR_OPCODE        As Integer = 8
Public Const LGERR_ROOTNEXT      As Integer = 9

' Options for SelectArea:
Public Const SA_CLOSED     As Integer = 2   ' must be closed
Public Const SA_ONE        As Integer = 4   ' just one contour
Public Const SA_WANT_ECS   As Integer = 8   ' fill in ecs

' Flags for CleanUp
Public Const CINT_fCLN_GRP    As Integer = (2 ^ 0)
Public Const CINT_fCLN_LAY    As Integer = (2 ^ 1)
Public Const CINT_fCLN_PEN    As Integer = (2 ^ 2)
Public Const CINT_fCLN_STL    As Integer = (2 ^ 3)
Public Const CINT_fCLN_COL    As Integer = (2 ^ 4)
Public Const CINT_fCLN_WID    As Integer = (2 ^ 5)
Public Const CINT_fCLN_MAK    As Integer = (2 ^ 6)      ' only clean within macro
Public Const CINT_fCLN_POL    As Integer = (2 ^ 7)      ' break up Polylines
Public Const CINT_fCLN_UEB    As Integer = (2 ^ 8)      ' merge overlapping elements
Public Const CINT_fCLN_ALN    As Integer = (2 ^ 9)      ' ausgezogene Linien lschen
Public Const CINT_fCLN_EPT    As Integer = (2 ^ 10)     ' Endpunkte gleich setzen
Public Const CINT_fCLN_PHI    As Integer = (2 ^ 11)     ' Winkel korrigieren

' 'flags' of 'SetVisibility()'
Public Const IV_THESE_VISI      As Long = 0
Public Const IV_THESE_INVISI    As Long = 1
Public Const IV_THESE_UNCHGD    As Long = 2
Public Const IV_OTHERS_VISI     As Long = 0
Public Const IV_OTHERS_INVISI   As Long = 4
Public Const IV_OTHERS_UNCHGD   As Long = 8

Public Const E_ISINVISI As Long = (2 ^ 15)

'*********************************************************************************
' retrieve current pattern settings
Declare Sub GetPatternVal Lib "megavbasic.dll" Alias "_GetPatternVal@4" ( _
   ByRef pat As t_pattern)
   
Declare Function GetExpression Lib "megavbasic.dll" Alias "_GetExpression@8" _
       (ByVal szString As String, _
        ByRef retval As Double) As Integer
        
Declare Function GetCurrentFile Lib "megavbasic.dll" Alias "_GetCurrentFile@4" _
       (ByRef szString As String) As Integer
       
Declare Function GetPntInv Lib "megavbasic.dll" Alias "_GetPntInv@12" ( _
        ByRef pkt As t_point, _
        ByVal setinc As Integer, _
        ByVal func As Long) As Integer
        
Declare Function GetPnt Lib "megavbasic.dll" Alias "_GetPnt@12" ( _
        ByRef pkt As t_point, _
        ByRef lID As Long, _
        ByVal setinc As Integer) As Integer
                    
Declare Sub SetFuncText Lib "megavbasic.dll" Alias "_SetFuncText@4" _
       (ByVal szString As String)
         
Declare Function StringInput Lib "megavbasic.dll" Alias "_StringInput@8" _
       (ByVal szTitle As String, _
        ByRef szBuf As String) As Integer
        
Declare Function Message Lib "megavbasic.dll" Alias "_Message@24" _
       (ByVal str1 As String, _
        ByVal str2 As String, _
        ByVal but1 As String, _
        ByVal but2 As String, _
        ByVal but3 As String, _
        ByVal defbut As Integer) As Integer
        
Declare Function GetFilename Lib "megavbasic.dll" Alias "_GetFilename@8" _
       (ByVal szTitle As String, _
        ByRef szFileName As String) As Integer
        
Declare Sub MegaCMD Lib "megavbasic.dll" Alias "_MegaCMD@4" _
       (ByVal szCommand As String)
  
Declare Sub GetTextVal Lib "megavbasic.dll" Alias "_GetTextVal@12" _
       (ByVal iType As Integer, _
        ByVal iInit As Integer, _
        ByRef txt As t_text)
        
Declare Sub GetDimVal Lib "megavbasic.dll" Alias "_GetDimVal@12" _
       (ByVal iType As Integer, _
        ByVal iInit As Integer, _
        ByRef pDim As t_dimension)
        
        
Declare Sub GetDimSets Lib "megavbasic.dll" Alias "_GetDimSets@4" ( _
        ByRef ds As t_dimsets)

Declare Sub SetDimSets Lib "megavbasic.dll" Alias "_SetDimSets@4" ( _
        ByRef ds As t_dimsets)

Declare Function IsMod2D Lib "megavbasic.dll" Alias "_IsMod2D@0" _
        () As Long
        
Declare Sub NameLoop Lib "megavbasic.dll" Alias "_NameLoop@12" _
       (ByVal filter1 As Long, _
        ByVal filter1 As Long, _
        ByVal func As Long)
                
Declare Sub MouseHelp Lib "megavbasic.dll" Alias "_MouseHelp@12" _
       (ByVal str1 As String, _
        ByVal str2 As String, _
        ByVal inv As Integer)
        
Declare Function CreateEntity Lib "megavbasic.dll" Alias "_CreateEntity@24" _
       (ByVal iType As Integer, _
        ByRef attr As t_attribs, _
        ByRef data As Any, _
        ByRef appl As t_applic, _
        ByRef ecs As t_mat44, _
        ByVal idPrev As Long) As Long

Declare Sub savecount Lib "megavbasic.dll" Alias "_savecount@0" ()

Declare Sub StoreMultiple Lib "megavbasic.dll" Alias "_StoreMultiple@8" _
        (ByRef data As Any, _
         ByVal iType As Integer)
         
Declare Sub StoreMultiple3D Lib "megavbasic.dll" Alias "_StoreMultiple3D@12" _
        (ByRef data As Any, _
         ByVal iType As Integer, _
         ByRef ecs As t_mat44)

Declare Sub DrawInv Lib "megavbasic.dll" Alias "_DrawInv@16" _
       (ByVal iType As Integer, _
        ByRef ptr As Any, _
        ByVal lmode As Long, _
        ByVal atype As Integer)

Declare Sub DrawInv3D Lib "megavbasic.dll" Alias "_DrawInv3D@20" _
       (ByVal iType As Integer, _
        ByRef ptr As Any, _
        ByVal lmode As Long, _
        ByVal atype As Integer, _
        ByRef ecs As t_mat44)

Declare Function lmode Lib "megavbasic.dll" Alias "_LMODE@16" _
       (ByVal style As Integer, _
        ByVal pixmode As Integer, _
        ByVal col As Integer, _
        ByVal width As Integer) As Long
        
Declare Function HLP_INV Lib "megavbasic.dll" Alias "_HLP_INV@12" _
       (ByVal fore As Integer, _
        ByVal back As Integer, _
        ByVal sound As Boolean) As Integer
        
Declare Function Blink Lib "megavbasic.dll" Alias "_Blink@4" _
       (ByVal func As Long) As Boolean

Declare Sub EraseInv Lib "megavbasic.dll" Alias "_EraseInv@0" ()

Declare Function ClickEntity Lib "megavbasic.dll" Alias "_ClickEntity@32" _
       (ByVal filter1 As Long, _
        ByVal filter2 As Long, _
        ByRef pnt As t_point, _
        ByRef pnt3d As t_point3D, _
        ByVal snp_mod As Long, _
        ByRef ent As t_entity, _
        ByRef ecs As t_mat44, _
        ByVal fModify As Boolean) As Integer
        
Declare Function ClickMacro Lib "megavbasic.dll" Alias "_ClickMacro@8" ( _
        ByRef pnt As t_point, _
        ByRef ent As t_entity) As Integer
        
Declare Function GetEntity Lib "megavbasic.dll" Alias "_GetEntity@12" ( _
        ByVal id As Long, _
        ByRef ent As t_entity, _
        ByRef ecs As t_mat44) As Integer
                
Declare Function DeleteEntity Lib "megavbasic.dll" Alias "_DeleteEntity@4" ( _
        ByVal id As Long) As Integer
        
Declare Sub GetEntityData Lib "megavbasic.dll" Alias "_GetEntityData@8" _
       (ByRef pData As Any, _
        ByRef entity As t_entity)

Declare Sub SetEntityData Lib "megavbasic.dll" Alias "_SetEntityData@8" _
       (ByRef pData As Any, _
        ByRef entity As t_entity)
        
Declare Function ExChangeEntity Lib "megavbasic.dll" Alias "_ExChangeEntity@8" _
       (ByRef ent As t_entity, _
        ByRef ecs As t_mat44) As Long

Declare Function ExChangeEntityData Lib "megavbasic.dll" Alias "_ExChangeEntityData@12" _
       (ByRef ent As t_entity, _
        ByRef data As Any, _
        ByRef ecs As t_mat44) As Long
        
Declare Sub PrintDimVal Lib "megavbasic.dll" Alias "_PrintDimVal@20" _
       (ByVal value As Double, _
        ByRef str As String, _
        ByVal tol1 As String, _
        ByVal tol2 As String)
        
Declare Sub EntityLoop Lib "megavbasic.dll" Alias "_EntityLoop@20" _
       (ByVal filter1 As Long, _
        ByVal filter2 As Long, _
        ByVal func As Long, _
        ByRef ent As t_entity, _
        ByRef ecs As t_mat44)
    
Declare Sub MacroLoop Lib "megavbasic.dll" Alias "_MacroLoop@24" _
       (ByVal filter1 As Long, _
        ByVal filter2 As Long, _
        ByVal start As Long, _
        ByVal func As Long, _
        ByRef ent As t_entity, _
        ByRef ecs As t_mat44)
    
Declare Sub InfoLoop Lib "megavbasic.dll" Alias "_InfoLoop@4" ( _
        ByVal func As Long)
        
Declare Sub GetLastInfo Lib "megavbasic.dll" Alias "_GetLastInfo@4" ( _
        ByRef inf As t_entinfo)

Declare Sub DrawEntities Lib "megavbasic.dll" Alias "_DrawEntities@8" _
       (ByRef iArray() As Long, _
        ByVal iCnt As Integer)
        
Declare Sub SelectInit Lib "megavbasic.dll" Alias "_SelectInit@8" _
       (ByVal filter1 As Long, _
        ByVal filter2 As Long)
        
Declare Sub SelectLoop Lib "megavbasic.dll" Alias "_SelectLoop@16" _
       (ByVal func As Long, _
        ByRef ent As t_entity, _
        ByRef ecs As t_mat44, _
        ByVal fModify As Boolean)
              
Declare Function SelectEntities Lib "megavbasic.dll" Alias "_SelectLoop@16" _
       (ByVal func As Long, _
        ByRef ent As t_entity, _
        ByRef ecs As t_mat44, _
        ByVal fModify As Boolean) As Long
              
Declare Function ReadTxtFile Lib "megavbasic.dll" Alias "_ReadTxtFile@12" _
        (ByVal fname As String, _
         ByRef bArray() As Byte, _
         ByVal size As Long) As Integer
                      
Declare Function InsertMacro Lib "megavbasic.dll" Alias "_InsertMacro@24" _
        (ByVal fname As String, _
         ByVal func As Long, _
         ByRef ent As t_entity, _
         ByRef ecs As t_mat44, _
         ByRef pmac As t_placemac, _
         ByVal idPrev As Long) As Integer
         
Declare Function DeleteMacro Lib "megavbasic.dll" Alias "_DeleteMacro@4" _
       (ByVal id As Long) As Integer
       
Declare Function GetMacroInfo Lib "megavbasic.dll" Alias "_GetMacroInfo@4" ( _
        ByRef MacInfo As t_macinfo) As Integer
       
Declare Function SetMacroInfo Lib "megavbasic.dll" Alias "_SetMacroInfo@4" ( _
        ByRef MacInfo As t_macinfo) As Integer
       
Declare Sub GetPntSymbol Lib "megavbasic.dll" Alias "_GetPntSymbol@4" _
        (ByRef sym As t_symbol)
        
Declare Sub ResetSavecount Lib "megavbasic.dll" Alias "_ResetSavecount@0" ()

Declare Sub DoZoom Lib "megavbasic.dll" Alias "_DoZoom@4" _
       (ByRef rect As t_rect)
        
Declare Sub GetZoom Lib "megavbasic.dll" Alias "_GetZoom@4" _
       (ByRef rect As t_rect)
               
Declare Sub SetHelpFunc Lib "megavbasic.dll" Alias "_SetHelpFunc@4" _
       (ByVal fpHelp As Long)
       
Declare Function WritePolyBmp Lib "megavbasic.dll" Alias "_WritePolyBmp@12" _
       (ByVal fname As String, _
        ByRef poly As t_polygon, _
        ByVal fMax As Byte) As Long
        
Declare Function WritePolyBmpSelect Lib "megavbasic.dll" Alias "_WritePolyBmpSelect@8" _
       (ByVal fname As String, _
        ByVal fMax As Byte) As Long
           
Declare Function StoreInfo Lib "megavbasic.dll" Alias "_StoreInfo@4" ( _
        ByRef inf As t_entinfo) As Integer
        
Declare Function GetInfo Lib "megavbasic.dll" Alias "_GetInfo@8" ( _
        ByVal iID As Integer, _
        ByRef inf As t_entinfo) As Integer
                    
Declare Function ExChangeInfo Lib "megavbasic.dll" Alias "_ExChangeInfo@4" ( _
        ByRef inf As t_entinfo) As Integer
        
Declare Sub GetAttributes Lib "megavbasic.dll" Alias "_GetAttributes@8" ( _
        ByVal iType As Integer, _
        ByRef attr As t_attribs)
        
Declare Sub SetGridSets Lib "megavbasic.dll" Alias "_SetGridSets@4" ( _
        ByRef grid As t_gridsets)

Declare Sub GetGridSets Lib "megavbasic.dll" Alias "_GetGridSets@4" ( _
        ByRef grid As t_gridsets)
        
Declare Function LG_GetFlags Lib "megavbasic.dll" Alias "_LG_GetFlags@8" ( _
        ByVal num As Integer, _
        ByVal fGrp As Integer) As Byte
        
Declare Function LG_CreateList Lib "megavbasic.dll" Alias "_LG_CreateList@8" ( _
        ByVal fname As String, _
        ByRef err As Integer) As Long
        
Declare Function LG_CreateLayerList Lib "megavbasic.dll" Alias "_LG_CreateLayerList@4" ( _
        ByRef err As Integer) As Long
        
Declare Function LG_CreateGroupList Lib "megavbasic.dll" Alias "_LG_CreateGroupList@4" ( _
        ByRef err As Integer) As Long
        
Declare Function LG_GetInfo Lib "megavbasic.dll" Alias "_LG_GetInfo@12" ( _
        ByVal hList As Long, _
        ByVal op As Long, _
        ByRef err As Integer) As Long
        
Declare Function LG_ItemOp Lib "megavbasic.dll" Alias "_LG_ItemOp@24" ( _
        ByVal hList As Long, _
        ByVal hItem As Long, _
        ByVal hItem2 As Long, _
        ByRef data As t_LayGrpDta, _
        ByVal op As Long, _
        ByRef err As Integer) As Long
        
Declare Function LG_Replace Lib "megavbasic.dll" Alias "_LG_Replace@12" ( _
        ByVal hLayList As Long, _
        ByVal hGrpList As Long, _
        ByVal fDel As Integer) As Integer
        '                                    fDel&1:delete hLay, fDel&2:delete hGrp
        
Declare Sub SetAttributes Lib "megavbasic.dll" Alias "_SetAttributes@8" ( _
        ByVal iType As Integer, _
        ByRef attr As t_attribs)
                        
Declare Function EntityLen Lib "megavbasic.dll" Alias "_EntityLen@8" ( _
        ByRef ent As t_entity, _
        ByRef dLen As Double) As Integer
        
Declare Function PartList Lib "megavbasic.dll" Alias "_PartList@12" ( _
        ByVal fmt As String, _
        ByVal out As String, _
        ByVal flags As Byte) As Integer
' flags: PART_...
                
                
'res' = 'akt' * 'solve'
Declare Sub MatSolve Lib "megavbasic.dll" Alias "_MatSolve@12" ( _
        ByRef akt As t_mat44, _
        ByRef solve As t_mat44, _
        ByRef res As t_mat44)
                  
Declare Function PointsToEcs Lib "megavbasic.dll" Alias "_PointsToEcs@16" ( _
        ByRef pt1 As t_point3D, _
        ByRef pt1 As t_point3D, _
        ByRef pt1 As t_point3D, _
        ByRef ecs As t_mat44) As Long
        
Declare Sub PlaneToEcs Lib "megavbasic.dll" Alias "_PlaneToEcs@16" ( _
        ByRef xvec As t_vector3D, _
        ByRef yvec As t_vector3D, _
        ByRef origin As t_point3D, _
        ByRef ecs As t_mat44)
        
Declare Sub SetUcs Lib "megavbasic.dll" Alias "_SetUcs@4" ( _
        ByRef ecs As t_mat44)
       
Declare Sub GetUcs Lib "megavbasic.dll" Alias "_GetUcs@4" ( _
        ByRef ecs As t_mat44)
        
Declare Function CheckMat Lib "megavbasic.dll" Alias "_CheckMat@8" ( _
        ByRef ecs As t_mat44, _
        ByRef change As Long) As Long
        
Declare Function FindPolyLine Lib "megavbasic.dll" Alias "_FindPolyLine@4" ( _
        ByRef pkt As t_point) As Long
        
Declare Function SaveCurrentFile Lib "megavbasic.dll" Alias "_SaveCurrentFile@8" _
       (ByVal fname As String, _
        ByVal flags As Long) As Long
        
Declare Function GetMacroPos Lib "megavbasic.dll" Alias "_GetMacroPos@16" _
       (ByVal id As Long, _
        ByRef mat As t_mat33, _
        ByRef pnt As t_point3D, _
        ByRef d2D As t_MacroPosData) As Integer

Declare Function IsMacroExclusive Lib "megavbasic.dll" Alias "_IsMacroExclusive@4" _
       (ByVal id As Long) As Long
        
Declare Sub DrawInvID Lib "megavbasic.dll" Alias "_DrawInvID@8" ( _
        ByVal id As Long, _
        ByVal lmode As Integer)
        
Declare Function DoAttribDlg Lib "megavbasic.dll" Alias "_DoAttribDlg@4" _
       (ByRef Stl As t_AttribValues) As Long
       
Declare Function DoLayerDlg Lib "megavbasic.dll" Alias "_DoLayerDlg@4" _
       (ByRef iLayer As Long) As Long
             
Declare Function DoGroupDlg Lib "megavbasic.dll" Alias "_DoGroupDlg@4" _
       (ByRef iGroup As Long) As Long
                    
Declare Function DoPenDlg Lib "megavbasic.dll" Alias "_DoPenDlg@4" _
       (ByRef iPen As Long) As Long
             
Declare Function DoWidthDlg Lib "megavbasic.dll" Alias "_DoWidthDlg@4" _
       (ByRef iWidth As Long) As Long
             
Declare Function DoLineStyleDlg Lib "megavbasic.dll" Alias "_DoLineStyleDlg@4" _
       (ByRef iLStyle As Long) As Long
             
Declare Function DoColourDlg Lib "megavbasic.dll" Alias "_DoColourDlg@8" _
       (ByRef iColour As Long, _
        ByRef RGB As Long) As Long
' RGB ist vom Typ COLORREF

Declare Function InputPolyline Lib "megavbasic.dll" Alias "_InputPolyline@4" _
       (ByRef iID As Long) As Long

Declare Function GetLastValidIDs Lib "megavbasic.dll" Alias "_GetLastValidIDs@12" _
       (ByRef pid() As Long, _
        ByVal uCnt As Long, _
        ByVal uElmType As Long) As Integer

Declare Function SaveToPrt Lib "megavbasic.dll" Alias "_SaveToPrt@16" _
       (ByVal fname As String, _
        ByRef pid() As Long, _
        ByVal num As Long, _
        ByVal flags As Long) As Integer
        
Declare Function DoHatchDlg Lib "megavbasic.dll" Alias "_DoHatchDlg@4" _
       (ByRef Pattern As t_pattern) As Long
       
Declare Function SelectArea Lib "megavbasic.dll" Alias "_SelectArea@16" ( _
        ByRef ppt() As t_polypt, _
        ByVal iMaxCnt As Long, _
        ByVal fOptions As Long, _
        ByRef ecs As t_mat44) As Long
        
Declare Function GetMacroFileInfoXY Lib "megavbasic.dll" Alias "_GetMacroFileInfoXY@12" ( _
        ByVal pszFile As String, _
        ByRef AutoXY As t_rect, _
        ByRef MacInfo As t_macinfo) As Integer
                
Declare Sub SetIncPnt Lib "megavbasic.dll" Alias "_SetIncPnt@4" ( _
        ByRef pkt As t_point)
        
Declare Sub SetIncPnt3D Lib "megavbasic.dll" Alias "_SetIncPnt3D@4" ( _
        ByRef pkt As t_point3D)
        
        
Declare Function CleanUp Lib "megavbasic.dll" Alias "_CleanUp@8" ( _
        ByVal fOptions As Long, _
        ByVal dEpsilon As Double) As Long

Declare Function GetPntInv3D Lib "megavbasic.dll" Alias "_GetPntInv3D@12" ( _
        ByRef pkt As t_point3D, _
        ByVal setinc As Integer, _
        ByVal func As Long) As Integer
        
Declare Function GetPnt3D Lib "megavbasic.dll" Alias "_GetPnt3D@8" ( _
        ByRef pkt As t_point3D, _
        ByVal setinc As Integer) As Integer
        
Declare Sub InitObj3D Lib "megavbasic.dll" Alias "_InitObj3D@4" ( _
        ByRef obj As t_Obj3D)
        
Declare Sub FreeObj3D Lib "megavbasic.dll" Alias "_FreeObj3D@4" ( _
        ByRef obj As t_Obj3D)
        
Declare Function GetBodyGrav Lib "megavbasic.dll" Alias "_GetBodyGrav@4" ( _
        ByRef obj As t_Obj3D, _
        ByRef gpts As Double) As Long
        
Declare Function CreateCuboid Lib "megavbasic.dll" Alias "_CreateCuboid@32" ( _
        ByVal width As Double, _
        ByVal depth As Double, _
        ByVal height As Double, _
        ByRef ecs As t_mat44, _
        ByRef obj As t_Obj3D) As Long
        
Declare Function CreateCylinder Lib "megavbasic.dll" Alias "_CreateCylinder@32" ( _
        ByVal height As Double, _
        ByVal major As Double, _
        ByVal minor As Double, _
        ByRef ecs As t_mat44, _
        ByRef obj As t_Obj3D) As Long
        
Declare Function CreateCone Lib "megavbasic.dll" Alias "_CreateCone@40" ( _
        ByVal height As Double, _
        ByVal major As Double, _
        ByVal minor As Double, _
        ByVal top As Double, _
        ByRef ecs As t_mat44, _
        ByRef obj As t_Obj3D) As Long
        
Declare Function CreateSphere Lib "megavbasic.dll" Alias "_CreateSphere@16" ( _
        ByVal rad As Double, _
        ByRef ecs As t_mat44, _
        ByRef obj As t_Obj3D) As Long
        
 Declare Function CreateTorus Lib "megavbasic.dll" Alias "_CreateTorus@24" ( _
        ByVal major As Double, _
        ByVal minor As Double, _
        ByRef ecs As t_mat44, _
        ByRef obj As t_Obj3D) As Long
        
Declare Function CreateLin3D Lib "megavbasic.dll" Alias "_CreateLin3D@8" ( _
        ByRef lin As t_lin3D, _
        ByRef attr As t_attribs, _
        ByRef appl As t_applic) As Long
        
Declare Function CreatePrism Lib "megavbasic.dll" Alias "_CreatePrism@32" ( _
        ByVal cnt As Integer, _
        ByRef ppt() As t_polypt, _
        ByVal height As Double, _
        ByRef vec As t_vector3D, _
        ByVal is_solid As Long, _
        ByRef ecs As t_mat44, _
        ByRef obj As t_Obj3D) As Long
        
Declare Function CreateRotBody Lib "megavbasic.dll" Alias "_CreateRotBody@28" ( _
        ByVal cnt As Integer, _
        ByRef ppt() As t_polypt, _
        ByRef axis As t_line, _
        ByRef angle As t_angle_2, _
        ByVal is_solid As Long, _
        ByRef ecs As t_mat44, _
        ByRef obj As t_Obj3D) As Long
                                                        
Declare Function CurvIntrs Lib "megavbasic.dll" Alias "_CurvIntrs@16" ( _
        ByRef blank As t_Obj3D, _
        ByRef tool As t_Obj3D, _
        ByRef ecs As t_mat44, _
        ByRef curv As t_Obj3D) As Long
        
Declare Function BodyUnite Lib "megavbasic.dll" Alias "_BodyUnite@24" ( _
        ByRef tool As t_Obj3D, _
        ByRef blank As t_Obj3D, _
        ByVal del_t As Long, _
        ByVal del_b As Long, _
        ByRef ecs As t_mat44, _
        ByRef res As t_Obj3D) As Long
        
Declare Function BodySubtract Lib "megavbasic.dll" Alias "_BodySubtract@24" ( _
        ByRef tool As t_Obj3D, _
        ByRef blank As t_Obj3D, _
        ByVal del_t As Long, _
        ByVal del_b As Long, _
        ByRef ecs As t_mat44, _
        ByRef res As t_Obj3D) As Long
        
Declare Function BodyIntersect Lib "megavbasic.dll" Alias "_BodyIntersect@24" ( _
        ByRef tool As t_Obj3D, _
        ByRef blank As t_Obj3D, _
        ByVal del_t As Long, _
        ByVal del_b As Long, _
        ByRef ecs As t_mat44, _
        ByRef res As t_Obj3D) As Long
        
Declare Function CutBodyPlane Lib "megavbasic.dll" Alias "_CutBodyPlane@16" ( _
        ByRef obj As t_Obj3D, _
        ByVal upper As Integer, _
        ByRef plane As t_mat44, _
        ByRef res As t_Obj3D) As Long
        
Declare Sub ObjToIGS Lib "megavbasic.dll" Alias "_ObjToIGS@4" ( _
        ByVal fname As String)
        
Declare Function OffsetFace Lib "megavbasic.dll" Alias "_OffsetFace@16" ( _
        ByRef obj As t_Obj3D, _
        ByVal dist As Double, _
        ByRef ofst As t_Obj3D) As Long
        
Declare Function GetBGravVol Lib "megavbasic.dll" Alias "_GetBGravVol@12" ( _
        ByRef obj As t_Obj3D, _
        ByRef gpnt As t_point3D, _
        ByRef vol As Double) As Long
        
Declare Function Update2DViews Lib "megavbasic.dll" Alias "_Update2DViews@4" ( _
        ByVal flags As Long) As Integer
     
Declare Function CreateSweepBody Lib "megavbasic.dll" Alias "_CreateSweepBody@36" ( _
        ByVal cnt_path As Integer, _
        ByRef ppt_path() As t_polypt, _
        ByRef ecs_path As t_mat44, _
        ByVal cnt_prof As Integer, _
        ByRef ppt_prof() As t_polypt, _
        ByRef ecs_prof As t_mat44, _
        ByVal rigid As Boolean, _
        ByVal is_solid As Boolean, _
        ByRef obj As t_Obj3D) As Long
        
Declare Function GetOpenGLmode Lib "megavbasic.dll" Alias "_GetOpenGLmode@8" ( _
        ByVal id As Long, _
        ByRef ogl As t_OpenGL) As Long
                
Declare Function SetOpenGLmode Lib "megavbasic.dll" Alias "_SetOpenGLmode@8" ( _
        ByVal id As Long, _
        ByRef ogl As t_OpenGL) As Long
                
Declare Function PlanarFace Lib "megavbasic.dll" Alias "_PlanarFace@16" ( _
        ByVal cnt As Integer, _
        ByRef ppt() As t_polypt, _
        ByRef ecs As t_mat44, _
        ByRef obj As t_Obj3D) As Long
        
Declare Function MakeCylinderFace Lib "megavbasic.dll" Alias "_MakeCylinderFace@36" ( _
        ByVal height As Double, _
        ByVal major As Double, _
        ByVal minor As Double, _
        ByRef angle As t_angle_2, _
        ByRef ecs As t_mat44, _
        ByRef obj As t_Obj3D) As Long
        
Declare Function MakeConeFace Lib "megavbasic.dll" Alias "_MakeConeFace@44" ( _
        ByVal height As Double, _
        ByVal major As Double, _
        ByVal minor As Double, _
        ByVal top As Double, _
        ByRef angle As t_angle_2, _
        ByRef ecs As t_mat44, _
        ByRef obj As t_Obj3D) As Long
        
Declare Function MakeTorusFace Lib "megavbasic.dll" Alias "_MakeTorusFace@40" ( _
        ByVal major As Double, _
        ByVal minor As Double, _
        ByVal top As Double, _
        ByRef u_angle As t_angle_2, _
        ByRef v_angle As t_angle_2, _
        ByRef ecs As t_mat44, _
        ByRef obj As t_Obj3D) As Long
        
Declare Function MakeSphereFace Lib "megavbasic.dll" Alias "_MakeSphereFace@24" ( _
        ByVal rad As Double, _
        ByRef u_angle As t_angle_2, _
        ByRef v_angle As t_angle_2, _
        ByRef ecs As t_mat44, _
        ByRef obj As t_Obj3D) As Long
              
Declare Sub Pnt3DtoPnt2D Lib "megavbasic.dll" Alias "_Pnt3DtoPnt2D@12" ( _
        ByRef pnt3d As t_point3D, _
        ByRef lcs As t_mat44, _
        ByRef pnt2d As t_point)

Declare Sub Pnt2DtoPnt3D Lib "megavbasic.dll" Alias "_Pnt2DtoPnt3D@12" ( _
        ByRef pnt2d As t_point, _
        ByRef lcs As t_mat44, _
        ByRef pnt3d As t_point3D)
        
Declare Sub Pnt2DtoPnt2D Lib "megavbasic.dll" Alias "_Pnt2DtoPnt2D@16" ( _
        ByRef pt1 As t_point, _
        ByRef lcs1 As t_mat44, _
        ByRef lcs2 As t_mat44, _
        ByRef pt2 As t_point)
        
Declare Sub Pnt3DtoPnt3D Lib "megavbasic.dll" Alias "_Pnt3DtoPnt3D@16" ( _
        ByRef pt1 As t_point3D, _
        ByRef lcs1 As t_mat44, _
        ByRef lcs2 As t_mat44, _
        ByRef pt2 As t_point3D)
        
        
Declare Function GetEnclosingArea Lib "megavbasic.dll" Alias "_GetEnclosingArea@20" ( _
        ByRef ppt() As t_polypt, _
        ByVal iMaxCnt As Long, _
        ByVal fOptions As Long, _
        ByRef ecs As t_mat44, _
        ByRef pnt2d As t_point) As Long
        
Declare Function SaveToMac Lib "megavbasic.dll" Alias "_SaveToMac@20" ( _
        ByRef mac As t_macro, _
        ByRef pnt3d As t_point3D, _
        ByRef aIDs() As Long, _
        ByVal cnt As Long, _
        ByVal flags As Long) As Integer
        
Declare Sub WantInvisible Lib "megavbasic.dll" Alias "_WantInvisible@4" ( _
        ByVal fWant As Boolean)
               
Declare Sub SetVisibility Lib "megavbasic.dll" Alias "_SetVisibility@12" _
       (ByRef iArray() As Long, _
        ByVal iCnt As Integer, _
        ByVal lFlags As Long)
               
Declare Sub GetLgBits Lib "megavbasic.dll" Alias "_GetLgBits@8" ( _
        ByRef laybits As t_LayerGroupUsedFlags, _
        ByRef grpbits As t_LayerGroupUsedFlags)

Declare Function IsLayGrpUsed Lib "megavbasic.dll" Alias "_IsLayGrpUsed@8" ( _
        ByRef laybits As t_LayerGroupUsedFlags, _
        ByVal iNumber As Long) As Boolean
              
Declare Sub SetTextVal Lib "megavbasic.dll" Alias "_SetTextVal@8" _
       (ByVal iType As Integer, _
        ByRef txt As t_text)
        
Declare Function CreateLayoutSheet Lib "megavbasic.dll" Alias "_CreateLayoutSheet@8" ( _
        ByRef ld As t_layoutdta, _
        ByVal fMkCurr As Boolean) As Long
        
Declare Function SetCurrentSheet Lib "megavbasic.dll" Alias "_SetCurrentSheet@4" ( _
        ByVal sid As Long) As Integer
                        
Declare Function GetCurrentSheet Lib "megavbasic.dll" Alias "_GetCurrentSheet@4" ( _
        ByRef ld As t_layoutdta) As Long
        
Declare Function SetSheetAllowed Lib "megavbasic.dll" Alias "_SetSheetAllowed@0" () As Integer

Declare Function StretchEntities Lib "megavbasic.dll" Alias "_StretchEntities@12" ( _
        ByRef rec As t_rect, _
        ByRef bpt As t_point3D, _
        ByRef zpt As t_point3D) As Integer
               
Declare Sub InvertChanged Lib "megavbasic.dll" Alias "_InvertChanged@0" ()

Declare Sub UpdateScreen Lib "megavbasic.dll" Alias "_UpdateScreen@4" ( _
        ByVal chkTime As Integer)
               
Declare Function GetModMultiWindw Lib "megavbasic.dll" Alias "_GetModMultiWindw@0" () As Integer
       
Declare Function MacroPos Lib "megavbasic.dll" Alias "_MacroPos@28" ( _
        ByVal fname As String, _
        ByVal func As Long, _
        ByRef pEntity As t_entity, _
        ByVal flags As Integer, _
        ByRef ref As t_mat44, _
        ByRef dst As t_mat44, _
        ByVal idPrev As Long) As Integer

Declare Sub HiddenLine Lib "megavbasic.dll" Alias "_HiddenLine@4" ( _
        ByRef ppara As t_ProjPara)
        
Declare Sub HiddenLineMac Lib "megavbasic.dll" Alias "_HiddenLineMac@16" ( _
        ByRef ppara As t_ProjPara, _
        ByVal num_obj As Long, _
        obj_list() As t_Obj3D, _
        ByVal fname As String)
        
Declare Sub HiddenLine2DSeg Lib "megavbasic.dll" Alias "_HiddenLine2DSeg@20" ( _
        ByRef ppara As t_ProjPara, _
        ByVal num_obj As Long, _
        obj_list() As t_Obj3D, _
        func As Long, _
        ent As t_entity)
        
Declare Sub GetAktProjPara Lib "megavbasic.dll" Alias "_GetAktProjPara@4" ( _
        ByRef ppara As t_ProjPara)
        
Declare Sub BegDrawInvObj3D Lib "megavbasic.dll" Alias "_BegDrawInvObj3D@8" ( _
        ByRef obj As t_Obj3D, _
        ByRef DrwObj As t_DrawInvObj)
        
Declare Sub EndDrawInvObj3D Lib "megavbasic.dll" Alias "_EndDrawInvObj3D@4" ( _
        ByRef DrwObj As t_DrawInvObj)
        
Declare Sub DrawInvObj3D Lib "megavbasic.dll" Alias "_DrawInvObj3D@16" ( _
        ByRef DrwObj As t_DrawInvObj, _
        ByVal lmode As Long, _
        ByVal atype As Integer, _
        ByRef ecs As t_mat44)
        
Declare Sub MatSuperpos Lib "megavbasic.dll" Alias "_MatSuperpos@12" ( _
        ByRef ecs1 As t_mat44, _
        ByRef ecs2 As t_mat44, _
        ByRef res As t_mat44)
        
Declare Sub GetBodyTransform Lib "megavbasic.dll" Alias "_GetBodyTransform@8" ( _
        ByRef obj As t_Obj3D, _
        ByRef ecs As t_mat44)
        
        
' pnt is a two dimensional array
Declare Function PntNetIntp Lib "megavbasic.dll" Alias "_PntNetIntp@8" ( _
        ByRef pnt() As t_point3D, _
        ByRef obj As t_Obj3D) As Long
        
Declare Function SkinWires Lib "megavbasic.dll" Alias "_SkinWires@12" ( _
        ByVal cnt As Long, _
        ByRef curv() As t_SkinCurv, _
        ByRef obj As t_Obj3D) As Long
               
Declare Function AdfSize Lib "megavbasic.dll" Alias "_AdfSize@8" ( _
        ByRef obj As t_Obj3D, _
        ByRef adf As t_Adf) As Long
               
Declare Function BodyToAdf Lib "megavbasic.dll" Alias "_BodyToAdf@8" ( _
        ByRef obj As t_Obj3D, _
        ByRef adf As t_Adf) As Long
        
Declare Function AdfToBody Lib "megavbasic.dll" Alias "_AdfToBody@8" ( _
        ByRef adf As t_Adf, _
        ByRef obj As t_Obj3D) As Long

Declare Function CutElem Lib "megavbasic.dll" Alias "_CutElem@16" ( _
        ByRef ent1 As t_entity, _
        ByRef ent2 As t_entity, _
        ByRef pnt As t_point3D, _
        ByRef cutp As t_point3D_4) As Long

Declare Sub SetAktProjPara Lib "megavbasic.dll" Alias "_SetAktProjPara@8" ( _
        ByRef ppara As t_ProjPara, _
        ByVal hid As Long)

Declare Function PlaneNormal Lib "megavbasic.dll" Alias "_PlaneNormal@8" ( _
        ByRef obj As t_Obj3D, _
        ByRef nev As t_vector3D) As Long

Declare Function PointsToFace Lib "megavbasic.dll" Alias "_PointsToFace@16" ( _
        ByRef pt1 As t_point3D, _
        ByRef pt2 As t_point3D, _
        ByRef pt3 As t_point3D, _
        ByRef obj As t_Obj3D) As Long

Declare Function FaceToPptSize Lib "megavbasic.dll" Alias "_FaceToPptSize@8" ( _
        ByRef obj As t_Obj3D, _
        ByRef cnt As Long) As Long
        
Declare Function FaceToPpt Lib "megavbasic.dll" Alias "_FaceToPpt@12" ( _
        ByRef obj As t_Obj3D, _
        ByRef cnt As Long, _
        ByRef pnts() As t_polypt) As Long
        
Declare Function SetBodyTransform Lib "megavbasic.dll" Alias "_SetBodyTransform@8" ( _
        ByRef obj As t_Obj3D, _
        ByRef ecs As t_mat44) As Long

' Parameter mod2D = TRUE --> mod2D else mod3D
Declare Sub SetMod2D Lib "megavbasic.dll" Alias "_SetMod2D@4" ( _
        ByVal mod2D As Integer)
        
Declare Function IsPlanarFace Lib "megavbasic.dll" Alias "_IsPlanarFace@4" ( _
        ByRef obj As t_Obj3D) As Long
        
Declare Function GetMod2D Lib "megavbasic.dll" Alias "_GetMod2D@0" _
        () As Long
        
Declare Sub Set0Ucs Lib "megavbasic.dll" Alias "_Set0Ucs@0" ()
        
Declare Sub GetSelectMode Lib "megavbasic.dll" Alias "_GetSelectMode@0" ()
        
Declare Function Pnt3DToFace Lib "megavbasic.dll" Alias "_Pnt3DToFace@12" ( _
        ByVal cnt As Long, _
        ByRef pnts() As t_point3D, _
        ByRef obj As t_Obj3D) As Long
        
'*************  Polylines *****************
Declare Function AddPolylnPt Lib "megavbasic.dll" Alias "_AddPolylnPt@20" _
       (ByRef poly As t_polyln, _
        ByVal x As Double, _
        ByVal y As Double) As Integer

Declare Function AddPolylnJump Lib "megavbasic.dll" Alias "_AddPolylnJump@20" _
       (ByRef poly As t_polyln, _
        ByVal x As Double, _
        ByVal y As Double) As Integer

Declare Function AddPolylnCir Lib "megavbasic.dll" Alias "_AddPolylnCir@28" _
       (ByRef poly As t_polyln, _
        ByVal x As Double, _
        ByVal y As Double, _
        ByVal mpd As Double) As Integer
        
Declare Function CalcPattern Lib "megavbasic.dll" Alias "_CalcPattern@16" ( _
        ByVal which As Integer, _
        ByVal cnt As Integer, _
        ByRef ppt() As t_polypt, _
        ByRef result As Double) As Integer
        
Declare Function CalcPatternPoint Lib "megavbasic.dll" Alias "_CalcPattern@16" ( _
        ByVal which As Integer, _
        ByVal cnt As Integer, _
        ByRef ppt() As t_polypt, _
        ByRef result As t_point) As Integer
        
Declare Function OpenPolBody Lib "megavbasic.dll" Alias "_OpenPolBody@4" ( _
        ByRef handle As Long) As Long
        
Declare Function AddPolBody Lib "megavbasic.dll" Alias "_AddPolBody@8" ( _
        ByVal handle As Long, _
        ByRef polyg As t_Polygon3D) As Long
        
Declare Function CleanBody Lib "megavbasic.dll" Alias "_CleanBody@4" ( _
        ByRef obj As t_Obj3D) As Long
        
Declare Function EnableFtree Lib "megavbasic.dll" Alias "_EnableFtree@4" ( _
        ByVal fEnable As Boolean) As Boolean
        
Declare Function OffsetBody Lib "megavbasic.dll" Alias "_OffsetBody@16" ( _
        ByRef hObj As t_Obj3D, _
        ByVal dist As Double, _
        ByRef hRes As t_Obj3D) As Long
        
Declare Function CreatePolBody Lib "megavbasic.dll" Alias "_CreatePolBody@8" ( _
        ByVal handle As Long, _
        ByRef obj As t_Obj3D) As Long
        
Declare Sub ClosePolBody Lib "megavbasic.dll" Alias "_ClosePolBody@4" ( _
        ByVal handle As Long)
        
Declare Function CountLumps Lib "megavbasic.dll" Alias "_CountLumps@4" ( _
        ByRef obj As t_Obj3D) As Long
        
Declare Sub EnableObj2D Lib "megavbasic.dll" Alias "_EnableObj2D@4" ( _
        ByVal fEnable As Byte)
                      
Declare Function LGINF_NEXTSTORE Lib "megavbasic.dll" Alias "_VB_LGINF_NEXTSTORE@4" ( _
        ByVal n As Long) As Long
        
Declare Function LGOP_FINDNUM Lib "megavbasic.dll" Alias "_VB_LGOP_FINDNUM@4" ( _
        ByVal n As Long) As Long
        
Declare Function LGOP_FINDVISI Lib "megavbasic.dll" Alias "_VB_LGOP_FINDVISI@4" ( _
        ByVal n As Long) As Long
        
Declare Function LGOP_FINDINDEX Lib "megavbasic.dll" Alias "_VB_LGOP_FINDINDEX@4" ( _
        ByVal n As Long) As Long
                
 '************* Low level helpers *****************
 
Declare Function C_asin Lib "megavbasic.dll" Alias "_C_asin@8" ( _
        ByVal phi As Double) As Double

Declare Function C_acos Lib "megavbasic.dll" Alias "_C_acos@8" ( _
        ByVal phi As Double) As Double

Declare Function C_atan2 Lib "megavbasic.dll" Alias "_C_atan2@16" ( _
        ByVal y As Double, _
        ByVal x As Double) As Double

Declare Function C_hypot Lib "megavbasic.dll" Alias "_C_hypot@16" ( _
        ByVal x As Double, _
        ByVal y As Double) As Double

Declare Function GetArrayElementCount Lib "megavbasic.dll" Alias "_GetArrayElementCount@8" ( _
        ByRef saArray() As Any, _
        ByVal iDim As Integer) As Long
    
Declare Sub CopyMemory Lib "KERNEL32" Alias "RtlMoveMemory" ( _
        lpvDest As Any, lpvSource As Any, ByVal cbCopy As Long)
    
Declare Sub MakeInvalid Lib "megavbasic.dll" Alias "_MakeInvalid@8" ( _
        ByRef lpvDest As Any, _
        ByVal iSize As Long)
    
Declare Sub TestVbArray Lib "megavbasic.dll" Alias "_TestVbArray@4" ( _
        ByRef lpvDest() As Any)
    
'***************  Wrappers **********************

Sub InitInterface()
    Call MakeInvalid(NO_t_mat44, Len(NO_t_mat44))
    Call MakeInvalid(NO_t_attribs, Len(NO_t_attribs))
    Call MakeInvalid(NO_t_applic, Len(NO_t_applic))
End Sub


